# gargantext-graph library

This lib gathers tools for graph management used in GarganText Project:
Functional Graph Library, Igraph bindings and new graph algorithms.

## Installation

First install [stack](https://docs.haskellstack.org/en/stable/install_and_upgrade/)
```bash
curl -sSL https://get.haskellstack.org/ | sh
```

For Debian like GNU/Linux OS, install dependencies 

```bash
sudo apt update && sudo apt install libblas-dev liblapack-dev
```

Then build and install:
```
stack install
```

## New Graph Clustering

You can run the clusterings used for the new Graph Clustering :

```
./run data/snap/amazon/com-amazon.ungraph.txt
```

Computed results :
- times.md gathers all runs with its computing time (for amazon and dblp graphs for now)
- Then you can get the results 
  - Summary of results for a beta of 0.0 :
    - com-amazon.ungraph.txt_0.0_gc.txt
  - Clustering result
    - com-amazon.ungraph.txt_1.0_gc.clusters.txt


## Files for the clustering tests/examples

- https://dl.gargantext.org/actor-movie.csv.bz2
- https://dl.gargantext.org/com-amazon.all.dedup.cmty.txt.bz2
- https://dl.gargantext.org/com-amazon.ungraph.txt.bz2
- https://dl.gargantext.org/com-dblp.ungraph.txt.bz2

### Results
- https://dl.gargantext.org/com-amazon.ungraph.txt_0.0_gc.clusters.txt
- https://dl.gargantext.org/com-amazon.ungraph.txt_1.0_gc.clusters.txt
